//
//  SNGBenBillingConfirmVC.swift
//  Nextgen Dev
//
//  Created by Cuong on 5/19/20.
//  Copyright © 2020 Chinh.nd. All rights reserved.
//

import UIKit

class SNGBenBillingDetailVC: SNGBaseViewController {
    @IBOutlet weak var header: SNGHead!
    @IBOutlet weak var colView: UICollectionView!
    @IBOutlet weak var btnConfirm: UIButton!
    @IBOutlet weak var btnCancel: UIButton!
    var isCreate : Bool = true
    var detail : SNGBeneficiaryModel?
    private var data: [SNGComboboxModel] = []
    let service = SNGBenModel()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        header.lbTitle.text = "settings.menu.ben.billing.detail.title".localized()
        header.selectBack = {
            self.backViewController()
        }

      
        self.btnConfirm.setTitle("settings.menu.ben.detail.btn.delete".localized(), for: .normal)
        self.btnCancel.setTitle("settings.menu.ben.detail.btn.edit".localized(), for: .normal)
        registerCell()
    }
    func registerCell() {
        colView.register(UINib(nibName: SNGCollectionViewCellDetail.className, bundle: nil),
                         forCellWithReuseIdentifier: SNGCollectionViewCellDetail.className)
    }
    override func viewWillAppear(_ animated: Bool) {
        self.createData()
    }

    func createData(){
        data.append(SNGComboboxModel(id: "settings.menu.ben.billing.serviceName", text: self.detail!.serviceName))
        if self.detail!.provinceName != "" {
            data.append(SNGComboboxModel(id: "settings.menu.ben.outside.provinceName.add", text: self.detail!.provinceName))
        }
        data.append(SNGComboboxModel(id: "settings.menu.ben.billing.providerName", text: self.detail!.providerName))
        data.append(SNGComboboxModel(id: "settings.menu.ben.billing.contractNo", text: self.detail!.billingNo))
        data.append(SNGComboboxModel(id: "settings.menu.ben.billing.hint", text: self.detail!.hintName))
        self.detail!.benType = "BILLING"
    }
    @IBAction func onDelete(_ sender: Any) {
        // Hiển thị confirm dialog xóa
              let agreeAction = Action(with: "Global.Agree".localized(), style: .normalRed) {[weak self] in
                  self?.handleDeleteConfirmation()
              }
              let closeAction = Action(with: "Global.Cancel".localized(), style: .normalGray) {}
              self.showPopupTemplate(title: "settings.menu.ben.delete.title".localized(), content: "settings.menu.ben.delete.notifiContent".localized(), actions: [agreeAction, closeAction], axis: .vertical)
    }
    
    private func handleDeleteConfirmation() {
           self.service.deleteBen(benId: self.detail!.id)
           self.service.completionSuccess = { message in
               DispatchQueue.main.async {
                   if message == "DELETE_SUCCESS" {
                    //Di chuyển đến màn hình danh sách
                    self.showPopUpWarning(viewControll: self, title: "settings.menu.ben.delete.success".localized(), content: "settings.menu.ben.delete.successContent".localized(), buttonText: "Global.Agree".localized(),type: TypeShowImagePopup.IMAGE, typeImage: .SUCCESS, successHandler: {
                        self.backViewController()
                    })
                   }
               }
           }
           
           self.service.completionFailed = { message in
            DispatchQueue.main.async {
                self.showError(error: message)
            }
           
           }
       }
    
    @IBAction func onUpdate(_ sender: Any) {
        let storyboard = UIStoryboard(name: "SNGBenBillingAdd", bundle: nil)
        let viewController = storyboard.instantiateViewController(withIdentifier: "SNGBenBillingAddVC") as! SNGBenBillingAddVC
        
        viewController.isCreate = false
        viewController.detail = self.detail
        self.navigationController?.pushViewController(viewController, animated: true)
    }
}

extension SNGBenBillingDetailVC: UICollectionViewDataSource, UICollectionViewDelegate {
    func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return self.data.count
    }
    func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        // Collection Overdraft Account
        let cell = collectionView.dequeueReusableCell(withReuseIdentifier: SNGCollectionViewCellDetail.className, for: indexPath) as! SNGCollectionViewCellDetail
        cell.key.text = self.data[indexPath.row].id.localized()
        cell.value.text = self.data[indexPath.row].text
        return cell
    }
}

// set style
extension SNGBenBillingDetailVC: UICollectionViewDelegateFlowLayout {
    func collectionView(_ collectionView: UICollectionView,
                        layout collectionViewLayout: UICollectionViewLayout,
                        minimumLineSpacingForSectionAt section: Int) -> CGFloat {
        return 0
    }
}
